/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.farm;

import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.JPanel;
import nl.cloudfarming.client.farm.model.Farm;
import nl.cloudfarming.client.farm.type.FarmDetailsPanel;
import org.openide.WizardDescriptor;

/**
 *
 * @author monezz
 */
public class FarmWizardDetailsVisual extends JPanel {

    private final FarmWizardDetailsPanel panel;
    private final Farm farm = new Farm();

    /**
     * Creates new form FarmWizardDetailsVisual
     */
    FarmWizardDetailsVisual(FarmWizardDetailsPanel panel) {
        FarmDetailsPanel farmDetailsPanel = new FarmDetailsPanel(farm);
        this.panel = panel;
        initComponents();
        setLayout(new BorderLayout());
        add(farmDetailsPanel);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setPreferredSize(new java.awt.Dimension(600, 400));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 600, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

    boolean valid(WizardDescriptor wizardDescriptor) {
        return true;
    }

    void read(WizardDescriptor wizardDescriptor) {
        String projectName = (String) wizardDescriptor.getProperty(FarmWizardIterator.PROP_PROJECT_NAME);
        if (projectName == null) {
            projectName = Bundle.Farm_default_name();
        }
        farm.setName(projectName);
        
        String registrationNumber = (String) wizardDescriptor.getProperty(Farm.PROP_REGISTRATIONNUMBER);
        farm.setRegistrationNumber(registrationNumber);        
    }

    void store(WizardDescriptor wizardDescriptor) {
        wizardDescriptor.putProperty(Farm.PROP_REGISTRATIONNUMBER, farm.getRegistrationNumber());
        wizardDescriptor.putProperty(FarmWizardIterator.PROP_PROJECT_NAME, farm.getName());
    }

    void validate(WizardDescriptor wizardDescriptor) {
        //TODO implement
    }
}
